# LRUCache.jl

[![CI](https://github.com/JuliaCollections/LRUCache.jl/actions/workflows/ci.yml/badge.svg)](https://github.com/JuliaCollections/LRUCache.jl/actions/workflows/ci.yml)
[![CI (Julia nightly)](https://github.com/JuliaCollections/LRUCache.jl/actions/workflows/ci-julia-nightly.yml/badge.svg)](https://github.com/JuliaCollections/LRUCache.jl/actions/workflows/ci-julia-nightly.yml)
[![License](http://img.shields.io/badge/license-MIT-brightgreen.svg?style=flat)](LICENSE.md)
[![codecov.io](http://codecov.io/github/JuliaCollections/LRUCache.jl/coverage.svg?branch=master)](http://codecov.io/github/JuliaCollections/LRUCache.jl?branch=master)

Provides a thread-safe implementation of a Least Recently Used (LRU) Cache for Julia.

An LRU Cache is a useful associative data structure (`AbstractDict` in Julia) that has a
set maximum size (as measured by number of elements or a custom size measure for items).
Once that size is reached, the least recently used items are removed first. A lock ensures
that data access does not lead to race conditions.

A particular use case of this package is to implement function memoization for functions
that can simultaneously be called from different threads.

See [LFUDACache.jl](https://github.com/OpenSesame/LFUDACache.jl) for a similar implementation of Least Frequently Used (LFU) caches.

## Installation
Install with the package manager via `]add LRUCache` or
```julia
using Pkg
Pkg.add("LRUCache")
```

## Interface

`LRU` supports the standard `AbstractDict` interface. Some examples of common
operations are shown below:

**Creation**

```julia
lru = LRU{K, V}(, maxsize = size [, by = ...] [,finalizer = ...])
```

Create an LRU Cache with a maximum size (number of items) specified by the *required*
keyword argument `maxsize`. Here, the size can be the number of elements (default), or the
maximal total size of the values in the dictionary, as counted by an arbitrary user
function (which should return a single value of type `Int`) specified with the keyword
argument `by`. Sensible choices would for example be `by = sizeof` for e.g. values which
are `Array`s of bitstypes, or `by = Base.summarysize` for values of some arbitrary user
type.

If `finalizer` is set, it is called for each entry that leaves the cache, with `key` and
`value` as arguments. This is useful if the cached values contain some resource that you
want to recover.

**Add an item to the cache**

```julia
setindex!(lru, value, key)
lru[key] = value
```

**Lookup an item in the cache**

```julia
getindex(lru, key)
lru[key]
```

**Change the maxsize**

```julia
resize!(lru; maxsize = size)
```

Here, the maximal size is specified via a required keyword argument. Remember that the
maximal size is not necessarily the same as the maximal length, if a custom function was
specified using the keyword argument `by` in the construction of the LRU cache.

**Empty the cache**

```julia
empty!(lru)
```

### Caching Use

To effectively use `LRU` as a cache, several functions from the `AbstractDict` interface
can be used for easy checking if an item is present, and if not quickly calculating a
default.

#### get!(lru::LRU, key, default)

Returns the value stored in `lru` for `key` if present. If not, stores `key =>
default`, and returns `default`.

#### get!(default::Callable, lru::LRU, key)

Like above, except if `key` is not present, stores `key => default()`, and
returns the result. This is intended to be used in `do` block syntax:

```julia
get!(lru, key) do
   ...
end
```

#### get(lru::LRU, key, default)

Returns the value stored in `lru` for `key` if present. If not, returns default without
storing this value in `lru`. Also comes in the following form:

#### get(default::Callable, lru::LRU, key)

#### cache_info(lru::LRU)

Returns an object holding a snapshot of information about hits, misses, current size, and total size in its properties.

The caching functions `get` and `get!` each contribute a cache hit or miss on every function call (depending on whether or not the key was found). `empty!` resets the counts of hits and misses to 0.

The other functions, e.g. `getindex` `iterate`, `haskey`, `setindex!`, `delete!`, and `pop!` do not contribute cache hits or misses, regardless of whether or not a key is retrieved. This is because it is not possible to use these functions for caching.

## Example

Commonly, you may have some long running function that sometimes gets called with the same
parameters more than once. As such, it may benefit from caching the results.

Here's our example, long running calculation:

```julia
function foo(a::Float64, b::Float64)
    sleep(100)
    result = a * b
end
```

As this function requires more than one parameter, we need a cache from
`(Float64, Float64)` to `Float64`. A cached version is then:

```julia
const lru = LRU{Tuple{Float64, Float64}, Float64}(maxsize=10)

function cached_foo(a::Float64, b::Float64)
    get!(lru, (a, b)) do
      foo(a,b)
    end
end
```

If we want to see how our cache is performing, we can call `cache_info` to see the number of cache hits and misses.

module SerializationExt
using LRUCache
using Serialization

function Serialization.serialize(s::AbstractSerializer, lru::LRU{K, V}) where {K, V}
    Serialization.writetag(s.io, Serialization.OBJECT_TAG)
    serialize(s, typeof(lru))
    serialize(s, length(lru))
    serialize(s, lru.maxsize)
    serialize(s, lru.hits)
    serialize(s, lru.misses)
    serialize(s, lru.lock)
    serialize(s, lru.by)
    serialize(s, lru.finalizer)
    for (k, val) in lru
        serialize(s, k)
        serialize(s, val)
        sz = lru.dict[k][3]
        serialize(s, sz)
    end
end

function Serialization.deserialize(s::AbstractSerializer, ::Type{LRU{K, V}}) where {K, V}
    n_items = Serialization.deserialize(s)
    maxsize = Serialization.deserialize(s)
    hits = Serialization.deserialize(s)
    misses = Serialization.deserialize(s)
    lock = Serialization.deserialize(s)
    by = Serialization.deserialize(s)
    finalizer = Serialization.deserialize(s)

    dict = Dict{K, Tuple{V, LRUCache.LinkedNode{K}, Int}}()
    sizehint!(dict, n_items)
    currentsize = 0
    # Create node chain
    first = nothing
    node = nothing
    for i in 1:n_items
        prev = node
        k = deserialize(s)
        node = LRUCache.LinkedNode{K}(k)
        val = deserialize(s)
        sz = deserialize(s)
        dict[k] = (val, node, sz)
        currentsize += sz
        if i == 1
            first = node
            continue
        else
            prev.next = node
            node.prev = prev
        end
    end
    # close the chain if any node exists
    if node !== nothing
        node.next = first
        first.prev = node
    end

    # Create a cyclic ordered set from the node chain
    keyset = LRUCache.CyclicOrderedSet{K}()
    keyset.first = first
    keyset.length = n_items

    # Create the LRU
    lru = LRU{K,V}(maxsize=maxsize)
    lru.dict = dict
    lru.keyset = keyset
    lru.currentsize = currentsize
    lru.hits = hits
    lru.misses = misses
    lru.lock = lock
    lru.by = by
    lru.finalizer = finalizer
    lru
end

end

using Base: IteratorEltype, HasEltype, HasLength, EltypeUnknown

mutable struct LinkedNode{T}
    val::T
    next::LinkedNode{T}
    prev::LinkedNode{T}

    # All new created nodes are self referential only
    function LinkedNode{T}(k::T) where {T}
        x = new{T}(k)
        x.next = x
        x.prev = x
        return x
    end
end

mutable struct CyclicOrderedSet{T} <: AbstractSet{T}
    first::Union{LinkedNode{T}, Nothing}
    length::Int

    CyclicOrderedSet{T}() where {T} = new{T}(nothing, 0)
end

CyclicOrderedSet(itr) = _CyclicOrderedSet(itr, IteratorEltype(itr))

_CyclicOrderedSet(itr, ::HasEltype) = CyclicOrderedSet{eltype(itr)}(itr)
function _CyclicOrderedSet(itr, ::EltypeUnknown)
    T = Base.@default_eltype(itr)
    (isconcretetype(T) || T === Union{}) || return grow_to!(CyclicOrderedSet{T}(), itr)
    return CyclicOrderedSet{T}(itr)
end
CyclicOrderedSet{T}(itr) where {T} = union!(CyclicOrderedSet{T}(), itr)

Base.IteratorSize(::Type{<:CyclicOrderedSet}) = HasLength()
Base.IteratorEltype(::Type{<:CyclicOrderedSet}) = HasEltype()
Base.length(s::CyclicOrderedSet) = s.length
Base.isempty(s::CyclicOrderedSet) = length(s) == 0

Base.empty(s::CyclicOrderedSet{T}, ::Type{U}=T) where {T,U} = CyclicOrderedSet{U}()

function Base.iterate(s::CyclicOrderedSet, state = s.first)
    if state === nothing
        return nothing
    else
        return state.val, state.next == s.first ? nothing : state.next
    end
end
function Base.iterate(s::Iterators.Reverse{<:LRUCache.CyclicOrderedSet},
    state = (s.itr.first isa Nothing) ? nothing : s.itr.first.prev)
    if state === nothing
        return nothing
    else
        return state.val, state.prev == s.itr.first.prev ? nothing : state.prev
    end
end

function Base.last(s::CyclicOrderedSet)
    isempty(s) && throw(ArgumentError("collection must be non-empty"))
    return s.first.prev.val
end

function Base.show(io::IO, s::CyclicOrderedSet)
    print(io, typeof(s))
    print(io, "([")
    if s.first !== nothing
        f = s.first
        show(io, f.val)
        n = f.next
        while n !== f
            print(io, ", ")
            show(io, n.val)
            n = n.next
        end
    end
    print(io, "])")
end

function _findnode(s::CyclicOrderedSet, x)
    isempty(s) && return nothing
    n = s.first
    while !isequal(n.val, x)
        n = n.next
        n == s.first && return nothing
    end
    return n
end

# adding items
function _push!(s::CyclicOrderedSet{T}, n::LinkedNode{T}) where {T}
    if isempty(s)
        s.first = n
    else
        list = s.first
        n.next = list
        n.prev = list.prev
        list.prev.next = n
        list.prev = n
    end
    s.length += 1
    return s
end
function Base.push!(s::CyclicOrderedSet{T}, x) where T
    n = _findnode(s, x)
    if n === nothing
        _push!(s, LinkedNode{T}(x))
    else
        _delete!(s, n)
        _push!(s, n)
    end
    return s
end
Base.pushfirst!(s::CyclicOrderedSet, x) = rotate!(push!(s, x))

# removing items
function _delete!(s::CyclicOrderedSet{T}, n::LinkedNode{T}) where {T}
    n.next.prev = n.prev
    n.prev.next = n.next
    s.length -= 1
    if n == s.first
        s.first = s.length == 0 ? nothing : n.next
    end
    return s
end
function Base.pop!(s::CyclicOrderedSet)
    isempty(s) && throw(ArgumentError("collection must be non-empty"))
    n = s.first.prev
    _delete!(s, n)
    return n.val
end
function Base.pop!(s::CyclicOrderedSet, x)
    n = _findnode(s, x)
    if n === nothing
        throw(KeyError(x))
    else
        _delete!(s, n)
        return x
    end
end
function Base.pop!(s::CyclicOrderedSet, x, default)
    n = _findnode(s, x)
    if n === nothing
        return default
    else
        _delete!(s, n)
        return x
    end
end
function Base.delete!(s::CyclicOrderedSet, x)
    n = _findnode(s, x)
    if n !== nothing
        _delete!(s, n)
    end
    return s
end
function Base.empty!(s::CyclicOrderedSet)
    s.first = nothing
    s.length = 0
    return s
end

# Rotate one step forward, so last element is now first
function rotate!(s::CyclicOrderedSet)
    if length(s) > 1
        s.first = s.first.prev
    end
    return s
end

function _move_to_front!(s::CyclicOrderedSet{T}, n::LinkedNode{T}) where {T}
    if s.first !== n
        n.next.prev = n.prev
        n.prev.next = n.next
        n.next = s.first
        n.prev = s.first.prev
        s.first.prev.next = n
        s.first.prev = n
        s.first = n
    end
    return s
end

using LRUCache
using LRUCache: CacheInfo
using Test
using Random
using Base.Threads

# Test insertion and reinsertion ordering
@testset "Single-threaded insertion and reinsertion" begin
    for cache in [LRU(; maxsize = 100), LRU{Int, Int}(; maxsize = 100)]
        r = 1:100
        for i in reverse(r)
            cache[i] = i
        end
        @test collect(cache) == collect(i=>i for i in r)

        for i = 1:10:100
            @test haskey(cache, i)
            @test !haskey(cache, 100+i)
        end

        # reinsert in random order
        p = randperm(100)
        for i in reverse(p)
            cache[i] = i
        end
        @test collect(cache) == collect(i=>i for i in p)
    end
end

@testset "Multi-threaded insertion and reinsertion" begin
    cache = LRU{Int, Int}(; maxsize = 100)

    r = 1:100
    @threads for i in reverse(r)
        cache[i] = i
    end

    @threads for i = 1:10:100
        @test haskey(cache, i)
        @test !haskey(cache, 100+i)
    end

    @test Set(cache) == Set(i=>i for i=1:100)

    @threads for i in 100:-1:1
        cache[i] = 2*i
    end

    @test Set(cache) == Set(i=>2*i for i=1:100)
end

@testset "Single-threaded getting and setting" begin
    cache = LRU{Int, Int}(; maxsize = 50*sizeof(Int), by = sizeof)

    for i in 100:-1:1
        @test 2*i == get(cache, i, 2*i)
        @test 2*i == get(()->2*i, cache, i)
        @test i == (iseven(i) ? get!(cache, i, i) : get!(()->i, cache, i))
        @test i == get!(cache, i, 2*i)
        @test i == get!(()->error("this should not happen"), cache, i)
        @test i == get(cache, i, 2*i)
        @test i == get(()->2*i, cache, i)
    end
    for i in 1:50
        @test haskey(cache, i)
        @test !haskey(cache, i+50)
        @test_throws KeyError getindex(cache, i+50)
    end

    @test collect(cache) == collect(i=>i for i in 1:50)

    p = randperm(50)
    for i in reverse(p)
        cache[i] = i
    end
    @test collect(cache) == collect(i=>i for i in p)

    p10 = p[1:10]
    resize!(cache; maxsize = 10*sizeof(Int))
    @test collect(cache) == collect(i=>i for i in p10)

    resize!(cache; maxsize = 50*sizeof(Int))
    @test collect(cache) == collect(i=>i for i in p10)

    for i in 50:-1:1
        @test get!(cache, i, 2*i) == (i in p10 ? i : 2*i)
    end

    for i in reverse(p10)
        @test cache[i] == i
    end
    resize!(cache; maxsize = 10*sizeof(Int))
    @test collect(cache) == collect(i=>i for i in p10)

    delete!(cache, p10[1])
    @test !haskey(cache, p10[1])

    @test p10[10] == pop!(cache, p10[10])
    @test !haskey(cache, p10[10])

    @test length(empty!(cache)) == 0
    @test isempty(cache)
    for i in p10
        @test !haskey(cache, p10)
    end
end

@testset "Multi-threaded getting and setting" begin
    cache = LRU{Int, Int}(; maxsize = 50*sizeof(Int), by = sizeof)

    @threads for i in 50:-1:1
        @test 2*i == get(cache, i, 2*i)
        @test 2*i == get(()->2*i, cache, i)
        @test i == (iseven(i) ? get!(cache, i, i) : get!(()->i, cache, i))
        @test i == get!(cache, i, 2*i)
        @test i == get!(()->error("this should not happen"), cache, i)
        @test i == get(cache, i, 2*i)
        @test i == get(()->2*i, cache, i)
    end

    p = randperm(50)
    p10 = p[1:10]
    @threads for i in p10
        @test cache[i] == i
    end
    resize!(cache; maxsize = 10*sizeof(Int))
    @test Set(cache) == Set(i=>i for i in p10)

    resize!(cache; maxsize = 50*sizeof(Int))
    @test Set(cache) == Set(i=>i for i in p10)

    delete!(cache, p10[1])
    @test !haskey(cache, p10[1])
    @test_throws KeyError getindex(cache, p10[1])

    @test p10[10] == pop!(cache, p10[10])
    @test !haskey(cache, p10[10])
    @test_throws KeyError getindex(cache, p10[1])
end

@testset "Recursive lock in get(!)" begin
    cache = LRU{Int,Int}(; maxsize = 100)
    p = randperm(100)
    cache[1] = 1

    f!(cache, i) = get!(()->(f!(cache, i-1) + 1), cache, i)
    @threads for i = 1:100
        f!(cache, p[i])
    end

    @threads for i = 1:100
        @test haskey(cache, i)
        @test cache[i] == i
    end
end

@testset "Eviction callback" begin
    # Julia 1.0 and 1.1 crash with multiple threads on this
    # combination of @threads and Channel.
    if VERSION >= v"1.2" || Threads.nthreads() == 1
        resources = Channel{Matrix{Float64}}(11)
        for _ = 1:11
            put!(resources, zeros(5, 5))
        end
        callback = (key, value) -> put!(resources, value)
        cache = LRU{Int,Matrix{Float64}}(; maxsize = 10, finalizer = callback)

        @threads for i = 1:100
            cache[i ÷ gcd(i, 60)] = take!(resources)
        end
        # Note: It's not ideal to rely on the Channel internals but there
        # doesn't seem to be a public way to check how much is occupied.
        @test length(resources.data) == 1
        cache[101] = take!(resources)
        @test length(resources.data) == 1
        pop!(cache, 101)
        @test length(resources.data) == 2
        cache[101] = take!(resources)
        @test length(resources.data) == 1
        delete!(cache, 101)
        @test length(resources.data) == 2
        get!(cache, 101, take!(resources))
        @test length(resources.data) == 1
        get!(() -> take!(resources), cache, 102)
        @test length(resources.data) == 1
        get!(() -> take!(resources), cache, 102)
        @test length(resources.data) == 1
        resize!(cache, maxsize = 5)
        @test length(resources.data) == 6
        empty!(cache)
        @test length(resources.data) == 11
        @test cache.maxsize == 5
    end
end

@testset "Reverse iterator" begin
    lru = LRU(;maxsize = 4)
    # Instantiate lazy reverse iterator
    rlru = Iterators.reverse(lru)
    # Did we handle the empty cache?
    @test [k => v for (k,v) in lru] == []
    @test [k => v for (k,v) in rlru] == []
    # Fill in some data
    lru["first"] = 1
    # Does a single element cache work
    @test [k => v for (k,v) in lru] == ["first" => 1]
    @test [k => v for (k,v) in rlru] == ["first" => 1]
    lru["second"] = 2
    # Does a partially filled cache work
    @test [k => v for (k,v) in lru] == ["second" => 2, "first" => 1]
    @test [k => v for (k,v) in rlru] == ["first" => 1, "second" => 2]
    lru["third"] = 3
    lru["fourth"] = 4
    # Does forward iteration give us the expected result?
    @test [k => v for (k,v) in lru] == ["fourth" => 4, "third" => 3, "second" => 2, "first" => 1]
    @test [k => v for (k,v) in rlru] == ["first" => 1, "second" => 2, "third" => 3, "fourth" => 4]
    # Evict first by inserting fifth
    lru["fifth"] = 5
    @test [k => v for (k,v) in lru] == ["fifth" => 5, "fourth" => 4, "third" => 3, "second" => 2]
    @test [k => v for (k,v) in rlru] == ["second" => 2, "third" => 3, "fourth" => 4, "fifth" => 5]
end

# https://github.com/JuliaCollections/LRUCache.jl/issues/37
@testset "Large entries" begin
    lru = LRU{Int, Vector{Int}}(; maxsize=10, by=length)
    get!(lru, 1, 1:9)
    @test !isempty(lru)
    @test lru[1] == 1:9

    # Add too-big entry
    get!(lru, 2, 1:11)
    # did not add entry 2, it is too big
    @test !haskey(lru, 2)

    # Still have old entries
    @test !isempty(lru)
    @test lru[1] == 1:9

    # Same with `setindex!`
    lru[2] = 1:11
    @test !haskey(lru, 2)
    @test !isempty(lru)
    @test lru[1] == 1:9

    # Add a second small entry
    lru[2] = 1:1
    @test haskey(lru, 2)
    @test lru[1] == 1:9
    @test lru[2] == 1:1

    # Re-assign it to a too-big entry
    lru[2] = 1:11
    @test !haskey(lru, 2) # don't keep the old entry!
    @test lru[1] == 1:9
end

@testset "cache_info" begin
    lru = LRU{Int, Float64}(; maxsize=10)

    get!(lru, 1, 1.0) # miss
    @test cache_info(lru) == CacheInfo(; hits=0, misses=1, currentsize=1, maxsize=10)

    get!(lru, 1, 1.0) # hit
    @test cache_info(lru) == CacheInfo(; hits=1, misses=1, currentsize=1, maxsize=10)

    get(lru, 1, 1.0) # hit
    @test cache_info(lru) == CacheInfo(; hits=2, misses=1, currentsize=1, maxsize=10)

    get(lru, 2, 1.0) # miss
    info = CacheInfo(; hits=2, misses=2, currentsize=1, maxsize=10)
    @test cache_info(lru) == info
    @test sprint(show, info) == "CacheInfo(; hits=2, misses=2, currentsize=1, maxsize=10)"

    # These don't change the hits and misses
    @test haskey(lru, 1)
    @test cache_info(lru) == info
    @test lru[1] == 1.0
    @test cache_info(lru) == info
    @test !haskey(lru, 2)
    @test cache_info(lru) == info

    # This affects `currentsize` but not hits or misses
    delete!(lru, 1)
    @test cache_info(lru) == CacheInfo(; hits=2, misses=2, currentsize=0, maxsize=10)

    # Likewise setindex! does not affect hits or misses, just `currentsize`
    lru[1] = 1.0
    @test cache_info(lru) == info

    # Only affects size
    pop!(lru, 1)
    @test cache_info(lru) == CacheInfo(; hits=2, misses=2, currentsize=0, maxsize=10)

    # Resets counts
    empty!(lru)
    @test cache_info(lru) == CacheInfo(; hits=0, misses=0, currentsize=0, maxsize=10)
end

include("originaltests.jl")
include("serializationtests.jl")

module Benchmark
using LRUCache

# This benchmark is a simple recursive Fibonnaci calculation. While not
# comparable to most real world problems, the simplicity of the underlying
# calculation means that most of the time is spent in the cacheing operations,
# rather than on the function itself. Which is optimal for comparing
# improvements to the cache speed.

const FIBCACHE = LRU{Int, Int}(; maxsize = 10)

function fib(a::Int)
    get!(FIBCACHE, a) do
        if a < 2
            a
        else
            fib(a - 1) + fib(a - 2)
        end
    end
end

function fib_benchmark(cachesize)
    resize!(FIBCACHE; maxsize = cachesize)
    empty!(FIBCACHE)
    println("Cache Size = $cachesize")
    @time fib(50)
end

println("========== BENCHMARKS ==========")
println()

println("Toss this timing, things are still compiling")
fib_benchmark(5)
println()
println("Fibonnaci Benchmarks")
println("--------------------")
for n in (10, 50, 100)
    fib_benchmark(n)
end
println()

# Now we benchmark individual operations
function setup_cache(cachesize, items)
    resize!(FIBCACHE; maxsize = cachesize)
    empty!(FIBCACHE)
    for i in items
        FIBCACHE[i] = i
    end
end
function benchmark_get(n)
    @time FIBCACHE[n]
end
function benchmark_set(k, v)
    @time FIBCACHE[k] = v
end

println("Access Benchmarks")
println("-----------------")
# Cache is [10, 9, 8, ...., 1] in order of use, and is full
setup_cache(10, 1:10)
println("Access for elements at head of cache")
for i in 1:5
    benchmark_get(10)
end
println()

# Cache is [10, 9, 8, ...., 1] in order of use, and is full
println("Access for elements not at head of cache")
for i in 1:5
    benchmark_get(i)
end
println()

println("Insertion Benchmarks")
println("--------------------")
# Cache is empty, with size 5
resize!(FIBCACHE; maxsize = 5)
empty!(FIBCACHE)
println("Insertion when cache is not full, element not in cache")
for i in 1:5
    benchmark_set(i, i)
end
println()

# Cache is [5, 4, 3, 2, 1]
println("Insertion when element already in cache, not at head")
for i in 1:5
    benchmark_set(i, i)
end
println()

# Cache is [5, 4, 3, 2, 1]
println("Insertion when element already in cache, at head")
for i in 1:5
    benchmark_set(5, 5)
end
println()

# Cache is [5, 4, 3, 2, 1]
println("Insertion when cache is full, element not in cache")
for i in 6:10
    benchmark_set(i, i)
end

end

using Serialization

function test_is_equivalent(a::LRU, b::LRU)
    # Check that the cache is the same
    @test a.maxsize == b.maxsize
    @test a.currentsize == b.currentsize
    @test a.hits == b.hits
    @test a.misses == b.misses
    @test a.by == b.by
    @test a.finalizer == b.finalizer
    @test a.keyset.length == b.keyset.length
    @test issetequal(collect(a), collect(b))
    # Check that the cache has the same keyset
    @test length(a.keyset) == length(b.keyset)
    @test all(((c_val, d_val),) -> c_val == d_val, zip(a.keyset, b.keyset))
    # Check that the cache keys, values, and sizes are the same
    for (key, (c_value, c_node, c_s)) in a.dict
        d_value, d_node, d_s = b.dict[key]
        c_value == d_value || @test false
        c_node.val == d_node.val || @test false
        c_s == d_s || @test false
    end
end

function roundtrip(lru::LRU)::LRU
    io = IOBuffer()
    serialize(io, lru)
    seekstart(io)
    deserialize(io)
end

@testset "Large Serialize and Deserialize" begin
    cache = LRU{Int, Int}(maxsize=100_000)

    # Populate the cache with dummy data
    num_entries_to_test = [0, 1, 2, 3, 4, 5, 100_000, 1_000_000]
    for i in 0:maximum(num_entries_to_test)
        # Add dummy data on all but the first iteration,
        # to test an empty cache
        i > 0 && (cache[i] = i+1)
        i ∈ num_entries_to_test || continue

        test_is_equivalent(cache, roundtrip(cache))
    end
end

@testset "Serialize mutable references" begin
    lru = LRU(; maxsize=5)
    a = b = [1]
    lru[1] = a
    lru[2] = b
    @test lru[1] === lru[2]
    lru2 = roundtrip(lru)
    @test lru2[1] === lru2[2]
end

@testset "Serialization with custom cache-size metric" begin
    lru = LRU{String,Vector{UInt8}}(; maxsize = 1024, by = sizeof)
    lru["a"] = rand(UInt8, 128)
    lru["b"] = rand(UInt8, 256)
    lru["c"] = rand(UInt8, 512)
    @test lru.currentsize == 896
    @test length(lru) == 3

    test_is_equivalent(lru, roundtrip(lru))
end

module LRUCache

include("cyclicorderedset.jl")
export LRU, cache_info

using Base.Threads
using Base: Callable

_constone(x) = 1

# Default cache size
mutable struct LRU{K,V} <: AbstractDict{K,V}
    dict::Dict{K, Tuple{V, LinkedNode{K}, Int}}
    keyset::CyclicOrderedSet{K}
    currentsize::Int
    maxsize::Int
    hits::Int
    misses::Int
    lock::SpinLock
    by::Any
    finalizer::Any

    function LRU{K, V}(; maxsize::Int, by = _constone, finalizer = nothing) where {K, V}
        dict = Dict{K, V}()
        keyset = CyclicOrderedSet{K}()
        new{K, V}(dict, keyset , 0, maxsize, 0, 0, SpinLock(), by, finalizer)
    end
end

Base.@kwdef struct CacheInfo
    hits::Int
    misses::Int
    currentsize::Int
    maxsize::Int
end

function Base.show(io::IO, c::CacheInfo)
    return print(io, "CacheInfo(; hits=$(c.hits), misses=$(c.misses), currentsize=$(c.currentsize), maxsize=$(c.maxsize))")
end

"""
    cache_info(lru::LRU) -> CacheInfo

Returns a `CacheInfo` object holding a snapshot of information about the cache hits, misses, current size, and maximum size, current as of when the function was called. To access the values programmatically, use property access, e.g. `info.hits`.

Note that only `get!` and `get` contribute to hits and misses, and `empty!` resets the counts of hits and misses to 0.

## Example

```jldoctest
lru = LRU{Int, Float64}(maxsize=10)

get!(lru, 1, 1.0) # miss

get!(lru, 1, 1.0) # hit

get(lru, 2, 2) # miss

get(lru, 2, 2) # miss

info = cache_info(lru)

# output

CacheInfo(; hits=1, misses=3, currentsize=1, maxsize=10)
```
"""
function cache_info(lru::LRU)
    lock(lru.lock) do
        return CacheInfo(; hits=lru.hits, misses=lru.misses, currentsize=lru.currentsize, maxsize=lru.maxsize)
    end
end

LRU(; maxsize::Int, by = _constone, finalizer = nothing) =
    LRU{Any,Any}(maxsize = maxsize, by = by, finalizer = finalizer)

Base.show(io::IO, lru::LRU{K, V}) where {K, V} =
    print(io, "LRU{$K, $V}(; maxsize = $(lru.maxsize))")

function Base.iterate(lru::LRU, state...)
    next = iterate(lru.keyset, state...)
    if next === nothing
        return nothing
    else
        k, state = next
        v, = lru.dict[k]
        return k=>v, state
    end
end
function Base.iterate(lru::Iterators.Reverse{<:LRU}, state...)
    next = iterate(Iterators.Reverse(lru.itr.keyset), state...)
    if next === nothing
        return nothing
    else
        k, state = next
        v, = lru.itr.dict[k]
        return k=>v, state
    end
end

Base.length(lru::LRU) = length(lru.keyset)
Base.isempty(lru::LRU) = isempty(lru.keyset)
function Base.sizehint!(lru::LRU, n::Integer)
    lock(lru.lock) do
        sizehint!(lru.dict, n)
    end
    return lru
end

_unsafe_haskey(lru::LRU, key) = haskey(lru.dict, key)
function Base.haskey(lru::LRU, key)
    lock(lru.lock) do
        return _unsafe_haskey(lru, key)
    end
end
function Base.get(lru::LRU, key, default)
    lock(lru.lock) do
        if _unsafe_haskey(lru, key)
            v = _unsafe_getindex(lru, key)
            lru.hits += 1
            return v
        else
            lru.misses += 1
            return default
        end
    end
end
function Base.get(default::Callable, lru::LRU, key)
    lock(lru.lock)
    try
        if _unsafe_haskey(lru, key)
            lru.hits += 1
            return _unsafe_getindex(lru, key)
        end
        lru.misses += 1
    finally
        unlock(lru.lock)
    end
    return default()
end
function Base.get!(lru::LRU{K, V}, key, default) where {K, V}
    evictions = Tuple{K, V}[]
    v = lock(lru.lock) do
        if _unsafe_haskey(lru, key)
            lru.hits += 1
            v = _unsafe_getindex(lru, key)
            return v
        end
        v = default
        _unsafe_addindex!(lru, v, key)
        _unsafe_resize!(lru, evictions)
        lru.misses += 1
        return v
    end
    _finalize_evictions!(lru.finalizer, evictions)
    return v
end
function Base.get!(default::Callable, lru::LRU{K, V}, key) where {K, V}
    evictions = Tuple{K, V}[]
    lock(lru.lock)
    try
        if _unsafe_haskey(lru, key)
            lru.hits += 1
            return _unsafe_getindex(lru, key)
        end
    finally
        unlock(lru.lock)
    end
    v = default()
    lock(lru.lock)
    try
        if _unsafe_haskey(lru, key)
            lru.hits += 1
            # should we test that this yields the same result as default()
            v = _unsafe_getindex(lru, key)
        else
            _unsafe_addindex!(lru, v, key)
            _unsafe_resize!(lru, evictions)
            lru.misses += 1
        end
    finally
        unlock(lru.lock)
    end
    _finalize_evictions!(lru.finalizer, evictions)
    return v
end

function _unsafe_getindex(lru::LRU, key)
    v, n, s = lru.dict[key]
    _move_to_front!(lru.keyset, n)
    return v
end
function Base.getindex(lru::LRU, key)
    lock(lru.lock) do
        if _unsafe_haskey(lru, key)
            v = _unsafe_getindex(lru, key)
            return v
        else
            throw(KeyError(key))
        end
    end
end
function _unsafe_addindex!(lru::LRU{K}, v, key) where K
    s = lru.by(v)::Int
    # If entry is larger than entire cache, don't add it
    s > lru.maxsize && return
    n = LinkedNode{K}(key)
    rotate!(_push!(lru.keyset, n))
    lru.currentsize += s
    lru.dict[key] = (v, n, s)
    return
end
function Base.setindex!(lru::LRU{K, V}, v, key) where {K, V}
    evictions = Tuple{K, V}[]
    lock(lru.lock) do
        if _unsafe_haskey(lru, key)
            old_v, n, s = lru.dict[key]
            if lru.finalizer !== nothing
                push!(evictions, (key, old_v))
            end
            lru.currentsize -= s
            s = lru.by(v)::Int
            # If new entry is larger than entire cache, don't add it
            # (but still evict the old entry!)
            if s > lru.maxsize
                # We are inside the lock still, so we will remove it manually rather than
                # `delete!(lru, key)` which would need the lock again.
                delete!(lru.dict, key)
                _delete!(lru.keyset, n)
            else # add the new entry
                lru.currentsize += s
                lru.dict[key] = (v, n, s)
                _move_to_front!(lru.keyset, n)
            end
        else
            _unsafe_addindex!(lru, v, key)
        end
        _unsafe_resize!(lru, evictions)
    end
    _finalize_evictions!(lru.finalizer, evictions)
    return lru
end

function _unsafe_resize!(lru::LRU{K, V}, evictions::Vector{Tuple{K, V}},
                         maxsize::Integer = lru.maxsize) where {K, V}
    lru.maxsize = maxsize
    while lru.currentsize > lru.maxsize
        key = pop!(lru.keyset)
        v, n, s = pop!(lru.dict, key)
        if lru.finalizer !== nothing
            push!(evictions, (key, v))
        end
        lru.currentsize -= s
    end
    return
end
function Base.resize!(lru::LRU{K, V}; maxsize::Integer = lru.maxsize) where {K, V}
    @assert 0 <= maxsize
    evictions = Tuple{K, V}[]
    lock(lru.lock) do
        _unsafe_resize!(lru, evictions, maxsize)
    end
    _finalize_evictions!(lru.finalizer, evictions)
    return lru
end

function Base.delete!(lru::LRU{K, V}, key) where {K, V}
    v = lock(lru.lock) do
        v, n, s = pop!(lru.dict, key)
        lru.currentsize -= s
        _delete!(lru.keyset, n)
        return v
    end
    if lru.finalizer !== nothing
        lru.finalizer(key, v)
    end
    return lru
end
function Base.pop!(lru::LRU{K, V}, key) where {K, V}
    (key, v) = lock(lru.lock) do
        v, n, s = pop!(lru.dict, key)
        lru.currentsize -= s
        _delete!(lru.keyset, n)
        return (key, v)
    end
    if lru.finalizer !== nothing
        lru.finalizer(key, v)
    end
    return v
end

function Base.empty!(lru::LRU{K, V}) where {K, V}
    evictions = Tuple{K, V}[]
    lock(lru.lock) do
        if lru.finalizer === nothing
            lru.currentsize = 0
            empty!(lru.dict)
            empty!(lru.keyset)
        else
            sizehint!(evictions, length(lru))
            maxsize = lru.maxsize
            _unsafe_resize!(lru, evictions, 0)
            lru.maxsize = maxsize # restore `maxsize`
        end
        lru.hits = 0
        lru.misses = 0
    end
    _finalize_evictions!(lru.finalizer, evictions)
    return lru
end

function _finalize_evictions!(finalizer, evictions)
    for (key, value) in evictions
        finalizer(key, value)
    end
    return
end

if !isdefined(Base, :get_extension)
    include("../ext/SerializationExt.jl")
end

end # module

@testset "Original tests" begin

function test_order(lru, keys, vals)
    for (i, (k,v)) = enumerate(lru)
        @test k == keys[i]
        @test v == vals[i]
    end
end

CACHE = LRU{Int, Int}(; maxsize = 20)
# Test insertion ordering
kvs = 1:10
for i in reverse(kvs)
    CACHE[i] = i
end
test_order(CACHE, 1:10, 1:10)

# Test reinsertion ordering
kvs = [1, 3, 5, 7, 9, 2, 4, 6, 8, 10]
for i in reverse(kvs)
    CACHE[i] = i
end
test_order(CACHE, kvs, kvs)

# Test least recently used items are evicted
resize!(CACHE; maxsize = 5)
test_order(CACHE, kvs[1:5], kvs[1:5])

resize!(CACHE; maxsize = 10)
test_order(CACHE, kvs[1:5], kvs[1:5])

kvs = 1:11
for i in reverse(kvs)
    CACHE[i] = i
end
test_order(CACHE, kvs[1:end-1], kvs[1:end-1])

# Test lookups, and that lookups reorder
kvs = 1:10
for i in reverse(kvs)
    CACHE[i] = 2*i
end
for i in kvs
    @test CACHE[i] == 2*i
end
test_order(CACHE, reverse(kvs), reverse(2*kvs))

# Test empty!
empty!(CACHE)
@test length(CACHE) == 0

# Test get! with default parameter
@test get!(CACHE, 1, 2)  == 2    # not in cache
@test get!(CACHE, 1, 2)  == 2    # in cache

# Test get! with function call
val = get!(CACHE, 2) do
          3
      end
@test val == 3
get!(CACHE, 2) do
    error("this shouldn't have been called!")
end

# Test Abstract typed cache. All we're checking for here is that the container
# is able to hold abstract types without issue. Insertion order is already
# tested above.
CACHE2 = LRU{String, Integer}(; maxsize = 5)
CACHE2["test"] = 4
@test CACHE2["test"] == 4

end
